#version 120

varying vec3  screenCoordsPassthrough;
varying vec4  position;
varying float  depthPassthrough;
varying vec3 passWorldPos;
varying vec3 passCameraPos;

uniform mat4 osg_ViewMatrixInverse;

void main(void)
{
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;

    mat4 scalemat = mat4(0.5, 0.0, 0.0, 0.0,
		 0.0, -0.5, 0.0, 0.0,
		 0.0, 0.0, 0.5, 0.0,
		 0.5, 0.5, 0.5, 1.0);

    vec4 texcoordProj = ((scalemat) * ( gl_Position));
    screenCoordsPassthrough = vec3(texcoordProj.x, texcoordProj.y, texcoordProj.w);

    position = gl_Vertex;

    depthPassthrough = gl_Position.z;

    passWorldPos = (osg_ViewMatrixInverse * gl_ModelViewMatrix * gl_Vertex).xyz;
    passCameraPos[0] = osg_ViewMatrixInverse[3][0];
    passCameraPos[1] = osg_ViewMatrixInverse[3][1];
    passCameraPos[2] = osg_ViewMatrixInverse[3][2];
}
